<?php
/*
Plugin Name: فرم پرداخت درگاه بهبانک
Plugin URI: http://www.behbank.com
Description: فرم پرداخت درگاه بهبانک
Author: epay123.ir
Author URI: http://www.epay123.ir
Version: 0.1
*/
session_start();
define('epay123','www.epay123.ir');
define('PLUGIN_DIR',dirname(__FILE__));
define('PLUGIN_URL',get_settings('siteurl').'/wp-content/plugins/gateway_form');
include_once('functions.php');
include_once('GateWay.php');

function gateway_style()
{
?>
	<style type="text/css" >
		.gateway-table{
			border-spacing:5px;
			font-size: 14px;
		}
		.gateway-table td{
			margin:3px;
		}
		.gateway-table input,
		.gateway-table textarea{
			width: 100%;
		}
		.gateway-textbox{
			padding:4px;
			width:200px;
			font:12px tahoma;
		}
		.gateway-button{
			cursor:pointer;
			padding:3px 15px;
		}
		.gateway-listbox{
			font:12px tahoma;
			width:210px;
			padding:4px;
		}
		.gateway-error,.gateway-message{
			text-align:center;
			margin:20px 0;
		}
		.gateway-error{
			color:red;
		}
		.gateway-success{
			color: green;
		}
		.gateway-title{
			font-family: tahoma;
			font-size: 14px;
			text-align:right;
			font-weight:bold;
		}
		#gateway-footer{
			text-align:left;
			margin:10px;
			font-size:11px;
		}
	</style>
    <script type="text/javascript" language="javascript" >
		function trim(str)
		{
			return str.replace(/^\s+|\s+$/g,'');
		}
		function gateway_ckeck_form()
		{
			fields=Array('amount','name','bankbill');
			var size=fields.length;
			var field;
			for(i=0;i<size;i++)
			{
				field=document.getElementById('gateway_COF_'+fields[i]);
				if(trim(field.value)=='')
				{
					alert('پر کردن فیلدهای ستاره دار الزامی است');
					field.value='';
					field.focus();
					return false;
				}
			}
		}
	</script>
    <?php
}
add_action('admin_head','gateway_style');
add_action('wp_head','gateway_style');

if(is_admin())
	add_action('admin_menu','gateway_menu');
function gateway_menu()
{
	add_options_page('تنظیمات فرم پرداخت بهبانک','فرم پرداخت بهبانک', 'manage_options','gateway','gateway_options');
}
function gateway_options()
{
	if (!current_user_can('manage_options'))
		wp_die( __('شما اجازه دسترسی به این صفحه را ندارید') );

	echo '<h3 id="gateway-title" > » تنظیمات فرم پرداخت بهبانک</h3>';
	if(isset($_POST['action']) && $_POST['action']=='update')
	{
		if(empty(trim($_POST['gateway_merchant'])))
			echo'<div class="gateway-error"> مرچنت کد درگاه خود را وارد کنید </div>';
		else
			update_option('gateway_merchant',escape($_POST['gateway_merchant']));
	}
	$gateway_merchant=get_option('gateway_merchant');
	?>
    <form method="post" >
	<table>
		<tr>
        	<td><label for="gateway_merchant" >مرچنت کد :  </label></td>
        	<td><input type="text" name="gateway_merchant" id="gateway_merchant" value="<?php echo $gateway_merchant; ?>" class="gateway-textbox" dir="ltr"  /></td>
		</tr>
		<tr>
			<td colspan="2">
				<input type="hidden" name="action" value="update"  />
        		<input type="submit" value=" ذخیره " class="gateway-button" />
			</td>
		</tr>
    </table>
	</form>
    <hr size="1" color="#999999" />
    <div id="gateway-footer" >
    	<a href="http://www.behbank.com" target="_blank" >www.BehBank.com</a>
    </div>
	<?php
}


function gateway_payment_form()
{
	$gateway_merchant = get_option('gateway_merchant');
	if(strtolower($_SERVER['REQUEST_METHOD']) == 'post' && isset($_POST['status']) && isset($_POST['invoiceNumber']) && isset($_POST['paymentNumber'])){
		if($_POST['status'] == 1){
			$mg = new GateWay();
			$params = array(
				'merchantCode' => $gateway_merchant,
				'paymentNumber' => $_POST['paymentNumber'],
			);
			$request = $mg->paymentVerify($params);
			if($request['status']){
				echo '<div class="gateway-success">پرداخت شما با موفقیت انجام شد، شماره پیگیری تراکنش : '.$_POST['paymentNumber'].'</div>';
			}else{
				echo '<div class="gateway-error">متاسفانه پرداخت شما تایید نشد - '.$request['message'].'</div>';
			}
		}else{
			echo '<div class="gateway-error">متاسفانه پرداخت انجام نشد</div>';
		}
	}
	if(isset($_POST['gateway_send']))
	{
		$fields=array('amount','name',);
		$error=false;
		foreach($fields as $field)
		{
			if(empty($_POST['gateway_'.$field]))
				$error=true;	
		}
		if($error)
			$error='پر کردن فیلدهای ستاره دار الزامی است';
		elseif(!is_numeric($_POST['gateway_amount']))
			$error='مقدار وارد شده برای مبلغ واریزی معتبر نیست';
		elseif($_POST['gateway_amount'] < 1000)
			$error = 'حداقل مبلغ قابل پرداخت 1000 ریال می باشد';
		elseif(strlen(trim($_POST['gateway_email'])) && !filter_var($_POST['gateway_email'], FILTER_VALIDATE_EMAIL))
			$error='پست الکترونیکی وارد شده معتبر نیست';
		elseif(strlen(trim($_POST['gateway_mobile'])) && !preg_match('/^09[0-9]{9}$/i', $_POST['gateway_mobile']))
			$error = 'شماره موبایل وارد شده معتبر نیست';
		elseif($_POST['gateway_token']!=$_SESSION['gateway_token'])
			$error='مشکلی وجود دارد - دوباره سعی کنید';
		if($error)
		{
			echo'<div class="gateway-error" >'.$error.'</div>';
		}
		else
		{
			$mg = new GateWay();
			$params = array(
				'merchantCode' => $gateway_merchant,
				'amount' => escape($_POST['gateway_amount']),
				'callBackUrl' => get_the_permalink(),
				'invoiceNumber' => time(),
				'payerName' => escape($_POST['gateway_name']),
			);
			if(strlen(trim($_POST['gateway_email']))){
				$params['payerEmail'] = escape($_POST['gateway_email']);
			}
			if(strlen(trim($_POST['gateway_mobile']))){
				$params['payerMobile'] = escape($_POST['gateway_mobile']);
			}
			if(strlen(trim($_POST['gateway_description']))){
				$params['description'] = escape($_POST['gateway_description']);
			}
			$request = $mg->paymentRequest($params);
			if($request['status']){
				$mg->paymentGateway($request['paymentNumber']);
			}else{
				echo  '<div class="gateway-error" > متاسفانه مشکلی در اتصال به درگاه پرداخت وجود دارد - '.$request['message'].'</div>';
			}
		}
	}
	?>
    <form action="" method="post" onSubmit="return gateway_ckeck_form();">
    <table align="center" class="gateway-table" >
		<tr>
			<td style="width: 200px;"><label for="gateway_amount" >مبلغ (ریال) * : </label></td>
			<td><input type="text" name="gateway_amount" id="gateway_amount" class="gateway-textbox" value="<?php echo post('gateway_amount'); ?>"  dir="ltr" /></td>
		</tr>
    	<tr>
        	<td><label for="gateway_name" >نام و نام خانوادگی * : </label></td>
            <td><input type="text" name="gateway_name" id="gateway_name" class="gateway-textbox" value="<?php echo post('gateway_name'); ?>"  dir="rtl" /></td>
        </tr>
    	<tr>
        	<td><label for="gateway_email" >پست الکترونیکی : </label></td>
            <td><input type="email" name="gateway_email" id="gateway_email" class="gateway-textbox" value="<?php echo post('gateway_email'); ?>"  dir="ltr" /></td>
        </tr>
    	<tr>
        	<td><label for="gateway_mobile" >شماره موبایل : </label></td>
            <td><input type="text" name="gateway_mobile" id="gateway_mobile" class="gateway-textbox" maxlength="11" value="<?php echo post('gateway_mobile'); ?>"  dir="ltr" /></td>
        </tr>
    	<tr>
        	<td><label for="gateway_description" >توضیحات : </label></td>
            <td><textarea name="gateway_description" id="gateway_description" class="gateway-textbox" ><?php echo post('gateway_description'); ?></textarea></td>
        </tr>
		<tr>
			<td colspan="2" >توجه : پر کردن فیلدهای ستاره دار الزامی است</td>
		</tr>
		</tr>
    	<tr>
            <td colspan="2" >
				<input type="hidden" name="gateway_token" value="<?php echo token(); ?>" />
				<input type="hidden" name="gateway_send" value="true" />
				<input type="submit" name="gateway_submit" value="پرداخت آنلاین" class="gateway-button"  />
			</td>
        </tr>
    </table>
    </form>
    <?php
}
add_shortcode('GateWayeForm','gateway_payment_form');

//  >>>>>>>>>>>>>>    Enjoy...   <<<<<<<<<<<<<<<
?>
